'use strict';'require view';'require dom';'require ui';'require form';'require rpc';'require fs';'require uci';document.querySelector('head').appendChild(E('link',{'rel':'stylesheet','type':'text/css','href':L.resource('view/live-sensor/css/custom.css')}));var connection=null;var sensorArray=[];const processSensorData=(data)=>{var dataType=data.data.dataTypeName;var sensorTimestamp=buildSensorTimestamp(data.data.ts);var sensorValues=buildSensorValues(data.data.values);var sensorObject={uuid:data.data.uuid,index:data.data.index,sensorType:data.data.sensorType,dataType:dataType,values:sensorValues,timestamp:sensorTimestamp}
renderSensorBoards(sensorObject);}
const buildSensorTimestamp=(timestamp)=>{var localDateTime=new Date(timestamp*1000).toLocaleString();return localDateTime;}
const buildSensorValues=(data)=>{var values='';for(var i=0;i<data.length;i++){if(!isNaN(data[i])){data[i]=parseFloat(data[i]).toFixed(2);}
values+=data[i]+', ';}
values=values.substring(0,values.length-2);return values;}
const getSocketConnection=()=>{connection=new WebSocket(`ws://${location.host}/socket.io/`)
connection.onmessage=async function(event){processSensorData(JSON.parse(event.data));}
connection.onopen=function(event){updateSocketStatus('green','Connected');connection.send('{"x":"hello"}')}
connection.onclose=function(event){updateSocketStatus('red','Disconnected');connection=null;setTimeout(getSocketConnection,5000);}
connection.onerror=function(event){updateSocketStatus('orange','Error');}}
const updateSocketStatus=function(color,status_msg){var socketStatus=document.getElementById('socket-status');socketStatus.style.background=color;socketStatus.innerHTML='<span>'+status_msg+'</span>';}
const getSensorContainer=async(sensorObject)=>{var sensorBoards=document.getElementById('power-analyzer-container');var sensorContainer;var sensorUuidDivs=document.querySelectorAll('[data-uuid="'+sensorObject.uuid+'"]');for(var i=0;i<sensorUuidDivs.length;i++){var sensorUuidDiv=sensorUuidDivs[i];var sensorType=sensorUuidDiv.getAttribute('data-sensor-type');if(sensorType==sensorObject.sensorType){sensorContainer=sensorUuidDiv;break;}}
if(!sensorContainer){sensorContainer=document.createElement('div');sensorContainer.setAttribute('data-uuid',sensorObject.uuid);sensorContainer.setAttribute('data-sensor-type',sensorObject.sensorType);sensorBoards.appendChild(sensorContainer);}
return sensorContainer;}
const getSensorCardBody=async(sensorContainer,sensorObject)=>{var sensorName=getSensorName(sensorObject);var sensorCard=document.getElementById(sensorName);if(!sensorCard){sensorCard=document.createElement('div');sensorCard.setAttribute('id',sensorName);sensorCard.setAttribute('class','card');sensorCard.setAttribute('data-card',sensorObject.uuid);sensorCard.setAttribute('data-index',sensorObject.index);var allSensorCards=document.querySelectorAll('[data-card="'+sensorObject.uuid+'"]');if(sensorObject.index==1||allSensorCards.length==0){sensorContainer.prepend(sensorCard);}else{var insertAfterCard;for(var i=0;i<allSensorCards.length;i++){if(allSensorCards[i].getAttribute('data-index')<sensorObject.index){insertAfterCard=allSensorCards[i];}else{break;}}
insertAfterCard.after(sensorCard);}
var sensorCardHeader=document.createElement('div');sensorCardHeader.setAttribute('class','card-header');sensorCardHeader.innerHTML='<b>Sensor:</b> '+sensorName;sensorCard.appendChild(sensorCardHeader);var sensorCardBody=document.createElement('div');sensorCardBody.setAttribute('class','card-body');sensorCard.appendChild(sensorCardBody);var sensorCardFooter=document.createElement('div');sensorCardFooter.setAttribute('class','card-footer');sensorCardFooter.setAttribute('id',sensorName+'-footer');sensorCard.appendChild(sensorCardFooter);}
return sensorCardBody;}
const getSensorTable=async(sensorCardBody,sensorName)=>{var sensorTable=document.getElementById(sensorName+'-table');if(!sensorTable){sensorTable=document.createElement('table');sensorTable.setAttribute('class','table table-striped table-bordered');sensorTable.setAttribute('id',sensorName+'-table');sensorCardBody.appendChild(sensorTable);}
return sensorTable;}
const getSensorRow=async(sensorTable,sensorObject)=>{var sensorName=getSensorName(sensorObject);var sensorRow=document.getElementById('tr-'+sensorName+'-'+sensorObject.dataType);if(!sensorRow){sensorRow=document.createElement('tr');sensorRow.setAttribute('id','tr-'+sensorName+'-'+sensorObject.dataType);sensorRow.setAttribute('data-row',sensorName);sensorRow.setAttribute('data-type',sensorObject.dataType);var sensorRows=document.querySelectorAll('[data-row="'+sensorName+'"]');if(sensorRows.length==0){sensorTable.appendChild(sensorRow);}else{var insertBeforeRow;for(var i=0;i<sensorRows.length;i++){if(sensorRows[i].getAttribute('data-type').toLowerCase().localeCompare(sensorObject.dataType.toLowerCase())==1){insertBeforeRow=sensorRows[i];break;}else{}}
if(insertBeforeRow){insertBeforeRow.before(sensorRow);}else{sensorTable.appendChild(sensorRow);}}}
return sensorRow;}
const updateSensorCells=(sensorRow,sensorObject)=>{var key=sensorObject.dataType;var values=sensorObject.values;var sensorName=getSensorName(sensorObject);var cell=document.getElementById(sensorName+'-'+key);if(!cell){var sensorCell=document.createElement('td');sensorCell.setAttribute('class','text-center');sensorCell.innerHTML=key;sensorRow.appendChild(sensorCell);var sensorCell=document.createElement('td');sensorCell.setAttribute('class','text-center');sensorCell.setAttribute('id',sensorName+'-'+key);sensorCell.innerHTML=values;sensorRow.appendChild(sensorCell);}else{var sensorCell=document.getElementById(sensorName+'-'+key);sensorCell.innerHTML=values;}}
const updateFooter=(sensorObject)=>{var timestamp=sensorObject.timestamp;var sensorName=getSensorName(sensorObject);var sensorFooter=document.getElementById(sensorName+'-footer');sensorFooter.innerHTML='<b>Last Updated:</b> '+timestamp;}
const getSensorName=(sensorObject)=>{var sensorName=sensorObject.uuid+'_'+sensorObject.sensorType+'_'+sensorObject.index;return sensorName;}
const renderSensorBoards=async(sensorObject)=>{var sensorName=getSensorName(sensorObject);var sensorContainer=await getSensorContainer(sensorObject);var sensorCardBody=await getSensorCardBody(sensorContainer,sensorObject);var sensorTable=await getSensorTable(sensorCardBody,sensorName);var sensorRow=await getSensorRow(sensorTable,sensorObject);updateSensorCells(sensorRow,sensorObject);updateFooter(sensorObject);}
return view.extend({load:function(){getSocketConnection();},render:function(){var body=E([E('div',{'id':'pa'},[E('h2',_('Live Sensor Data')),E('div',{'id':'socket-status'},'Connecting'),E('p',{},_('View the current status of your sensors.')),E('hr'),E('div',{'id':'power-analyzer-container'})])]);return body;}});